unit mapserv;

INTERFACE
uses
  graph, crt;
  function betrag( z: integer ): word;
  function zeilenEndWert(var zeile: string): integer;
  function nurName(name: string): string;
  function erweiterung(name: string; soll: string): string;
  procedure textEingabe(var intext: string; laenge, xpos, ypos: word; farbe: byte);
  function int2str( zahl: integer ): string;
  function int2chr( zahl: byte ): char;
  function str2int( zk: string ):integer;

IMPLEMENTATION

function str2int(zk: string): integer;
var
  code, zahl: integer;
begin
  val(zk, zahl, code);
  if code = 0 then str2int:= zahl else str2int:= 0;
end;

function int2str(zahl: integer): string;
var
  zk: string[5];
begin
  str(zahl, zk);
  int2str:= zk;
end;

function int2chr(zahl: byte): char;
var
  zk: string[1];
begin
  str(zahl, zk);
  int2chr:= zk[1];
end;

function nurName(name: string): string;
var
  hilf: string;
  i: byte;
begin
  hilf:= '';
  i:= length(name);
  if name <> '' then
  repeat
    if name[i] = '.' then hilf:='' else hilf:= name[i] + hilf;
    dec(i);
  until ((name[i] = '\') or (i = 0));
  nurName:= hilf;
end;

function erweiterung(name: string; soll: string): string;
var
  i: byte;
  so_lassen: boolean;
begin
  so_lassen:= true;
  for i:=0 to (length(soll)-1) do
    if upcase(name[length(name) - i]) <> upcase(soll[length(soll) - i])
    then so_lassen:= false;
  for i:= length(name) downto 0 do {2 Punkte im Dateinamen erlaubt DOS nicht}
    if name[i] = '.' then so_lassen:= true;
  if so_lassen then erweiterung:= name else erweiterung:= (name + soll);
end;

function betrag( z: integer ): word;
begin
  if z < 0 then betrag:= z * -1 else betrag:= z;
end;

procedure textEingabe(var intext: string; laenge, xpos, ypos: word; farbe: byte);
var
  ch: char;
  zaehl: word;
  zk: string;
begin
  zk:= '';
  zaehl:= 0;
  setfillstyle(1, red);
  bar((xpos - 1), (ypos - 1), (xpos + laenge * 8 - 1), (ypos + 7));
  repeat
    ch:=readkey;
    if ((ch <> char(13)) and (ch <> char(27))) then
    begin
      zk:= zk + ch;
      outtextxy( (xpos + zaehl * 8), ypos, ch);
    end;
    inc(zaehl);
  until ((ch = char(27)) or (ch = char(13)) or (zaehl >= laenge));
  if not(ch = char(27)) then intext:= zk;
  setfillstyle(1, farbe);
  bar((xpos - 1), (ypos - 1), (xpos + laenge * 8 - 1), (ypos + 7));
  outtextxy(xpos, ypos, intext);
end; {textEingabe}

function zeilenEndWert(var zeile: string): integer;
var
  i: byte;
  temp: string;
begin
  i:= length(zeile);
  while ((zeile[i] = ' ') and (i > 0)) do dec(i);
  delete(zeile, (i + 1), (length(zeile) - i)); {Leerzeichen am Ende lschen}
  i:= length(zeile);
  while ((zeile[i] <> ' ') and (zeile[i] <> '=') and (i > 0)) do dec(i);
  temp:= zeile;                         {Zeile zerlegen in Rest + EndWert}
  if i = 0 then zeile:= '' else delete(zeile, i, (length(zeile) - i + 1));
  delete(temp, 1, i);
  zeilenEndWert:= str2int(temp);
end;

end.